//+------------------------------------------------------------------+
//|                                                   ShowSeries.mq4 |
//|                                      Copyright  2009, Marketeer |
//|                                                          v.1.0.1 |
//|                                              http://www.mql4.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Marketeer"
#property link      "http://www.mql4.com"

#property indicator_chart_window

#property indicator_buffers 1
#property indicator_color1 Red

extern string FileName = "process.csv";
extern datetime StartDate = 0; // 0 - means now

double Buffer[];
int SeriesSize;

int GetFileCount()
{
  int count = 0;
  int handle = FileOpen(FileName, FILE_CSV|FILE_READ, ",");
  if(handle > 0)
  {
    while(!FileIsEnding(handle))
    {
      FileReadString(handle);
      count++;
    }
    FileClose(handle);
  }
  return(count);
}

int ReadFile(int offset)
{
  int count = 0;
  int handle = FileOpen(FileName, FILE_CSV|FILE_READ, ",");
  if(handle > 0)
  {
    while(!FileIsEnding(handle))
    {
      string x;
      x = FileReadString(handle);
      if(StringLen(StringTrimLeft(StringTrimRight(x))) == 0) break; // EOF
      Buffer[offset - count] = StrToDouble(x);
      count++;
    }
    FileClose(handle);
  }

}

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
  IndicatorBuffers(1);
  SetIndexStyle(0, DRAW_LINE);
  SetIndexBuffer(0, Buffer);
  SetIndexLabel(0, "Show series");
  
  if(StartDate == 0)
  {
    StartDate = Time[0];
  }
  
  SeriesSize = GetFileCount();
  int Offset = iBarShift(NULL, 0, StartDate);
  SetIndexShift(0, SeriesSize - Offset);
  
  return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
  return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
  static bool bFileRead = false;
  if(!bFileRead)
  {
    ReadFile(SeriesSize);
    bFileRead = true;
  }
  return(0);
}
//+------------------------------------------------------------------+